﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading.Tasks;

namespace SimpleTCPServer
{
    class Program
    {
        private static byte sensors = 0;
        static void Main(string[] args)
        {
            TcpListener server = null;
            try
            {
                Int32 port = 25232;
                IPAddress localAddr = IPAddress.Parse("127.0.0.1");
                server = new TcpListener(localAddr, port);
                server.Start();

                Byte[] bytes = new Byte[256];
                Console.Write("Waiting for a connection... ");
                TcpClient client = server.AcceptTcpClient();
                Console.WriteLine("Connected!");
                NetworkStream stream = client.GetStream();

                bool running = true;
                int cur_pos = 0;
                byte[] buffer = new byte[16];

                // Enter the listening loop.
                while (running)
                {
                    int i;

                    if (stream.DataAvailable)
                    {
                        // Loop to receive all the data sent by the client.
                        if ((i = stream.Read(bytes, 0, bytes.Length)) != 0)
                        {
                            buffer[cur_pos] = bytes[0];
                            cur_pos++;

                            if (bytes[0] == '!')
                            {
                                buffer[cur_pos] = (byte)'\0';
                                Console.WriteLine("Received: " + BitConverter.ToString(buffer));
                                cur_pos = 0;
                            }
                        }
                    }

                    if (Console.KeyAvailable)
                    {
                        ConsoleKeyInfo c = Console.ReadKey();
                        running = c.Key != ConsoleKey.Q;

                        if (c.Key == ConsoleKey.D1) SetBit(1);
                        else if (c.Key == ConsoleKey.D2) SetBit(2);
                        else if (c.Key == ConsoleKey.D3) SetBit(3);
                        else if (c.Key == ConsoleKey.D4) SetBit(4);
                        else if (c.Key == ConsoleKey.D5) SetBit(5);
                        else if (c.Key == ConsoleKey.D6) SetBit(6);
                        else if (c.Key == ConsoleKey.D7) SetBit(7);
                        else if (c.Key == ConsoleKey.D8) SetBit(8);
                        else if (c.Key == ConsoleKey.Enter)
                        {
                            byte[] b = { sensors };
                            stream.Write(b, 0, b.Length);
                            Console.WriteLine("\nSent byte: " + sensors + " [" + Convert.ToString(sensors, 2).PadLeft(8, '0') + "]");
                        }
                        else
                        {
                            sensors = (byte)c.KeyChar;
                            Console.WriteLine("\nByte is now: " + sensors + " [" + Convert.ToString(sensors, 2).PadLeft(8, '0') + "]");
                        }
                    }
                }
                client.Close();
            }
            catch (SocketException e)
            {
                Console.WriteLine("SocketException: {0}", e);
            }
            finally
            {
                server.Stop();
            }
        }

        private static void SetBit(byte p)
        {
            unchecked
            {
                sensors ^= (byte)(1 << (p - 1));
            }

            Console.WriteLine("\nByte is now: " + sensors + " [" + Convert.ToString(sensors, 2).PadLeft(8, '0') + "]");
        }
    }
}
